/*  FUNNEL LIBRARY
**  
**  Ref -- a simple reference cell implementation; might be used
**         by Funnel compilers to implement variables
**  
**  03/08/2K, Matthias Zenger
*/

newtype RefModule = {
    def create[a](initial: a): Ref[a]
}

newtype Ref[a] = {
    def value: a
    def update(x: a): ()
}

let Ref: RefModule = {
    def create[t] initial = {
        def value & state(x: t) = x & state(x)
        def update(x) & state(_) = () & state(x)
        current & state(initial)
    }
}
