/*  FUNNEL LIBRARY
**  
**  Stack -- a stack implementation
**  
**  20/06/2K, Matthias Zenger
*/

newtype Stack[a] = {
    def push(x: a): ()
    def pop: ()
    def top: a
    def isEmpty: boolean
    def toString: string
}

newtype StackModule = {
    def create[t]: Stack[t]
}

let Stack: StackModule = {
    def create[t]: Stack[t] = {
        def push(x) & empty() = () & full(x, empty)()
        def isEmpty & empty() = true & empty()
        def toString & empty() = "[]" & empty()
        def push(x) & full(ys: (t, () -> nil))() = () & full(x, full ys)()
        def pop & full(_, xs)() = () & xs()
        def top & full(x, xs)() = x & full(x, xs)()
        def isEmpty & full ys () = false & full ys ()
        def toString & full(x, xs)() = {
            val res = "[" + x + (toString' & xs());
            res & full(x, xs)()
        }
        def toString': string & empty() = "]"
        def toString' & full(x, xs)() = ", " + x + (toString' & xs())
        current & empty()
    }
}
