/*  FUNNEL LIBRARY
**  
**  String -- support for strings in Funnel
**  
**  11/06/2K, Matthias Zenger
*/

type String = string

newtype StringModule = {
    def charAt(s: string)(i: int): int
    def length(s: string): int
    def startsWith(s: string)(p: string): boolean
    def endsWith(s: string)(p: string): boolean
    def indexOf(s: string)(i: int)(j: int): int
    def lastIndexOf(s: string)(i: int)(j: int): int
    def substring(s: string)(f: int)(t: int): string
    def replace(s: string)(f: int)(t: int): string
    def toLowerCase(s: string): string
    def toUpperCase(s: string): string
    def trim(s: string): string
    def toInt(s: string): int
    def toLong(s: string): long
    def toFloat(s: string): float
    def toDouble(s: string): float
    def from(x: any): string
    def fromChar(c: int): string
}

let String: StringModule = {
    with Java
    val charAt = jmethod "charAt" (int_type)
    val length = jmethod "length" ()
    val startsWith = jmethod "startsWith" (java_lang_String)
    val endsWith = jmethod "endsWith" (java_lang_String)
    val indexOf = jmethod "indexOf" (int_type, int_type)
    val lastIndexOf = jmethod "lastIndexOf" (int_type, int_type)
    val substring = jmethod "substring" (int_type, int_type)
    val replace = jmethod "replace" (char_type, char_type)
    val toLowerCase = jmethod "toLowerCase" ()
    val toUpperCase = jmethod "toUpperCase" ()
    val trim = jmethod "trim" ()
    val toInt = jmethod "parseInt" (java_lang_String) java_lang_Integer
    val toLong = jmethod "parseLong" (java_lang_String) java_lang_Long
    val toFloat = jmethod "parseFloat" (java_lang_String) java_lang_Float
    val toDouble = jmethod "parseDouble" (java_lang_String) java_lang_Double
    def from(x) = "" + x
    val fromChar = jmethod "valueOf" (char_type) java_lang_String
}
