type DataInputStream = {
    with InputStream
    def readLine: string
    def readInt: int
    def readFloat: float
    def readUTF: string
}

newtype DataInputStreamModule = {
    def create(funnelstream: InputStream): DataInputStream
    def class: null
    def new(javastream: any): DataInputStream
    def extend(funnelstream: InputStream, javastream: any): DataInputStream
}

let DataInputStream: DataInputStreamModule = {
    val class = Java.jclass "java.io.DataInputStream"
    def new(in) = extend(InputStream.new(in), in)
    def create(stream) = {
        val newstream = Java.jconstructor(InputStream.class)class(stream.toJava)
        extend(InputStream.new(newstream), newstream)
    }
    def extend(stream, in) = {
        with stream
        def readLine = Java.jmethod "readLine" () in
        def readInt = Java.jmethod "readInt" () in
        def readFloat = Java.jmethod "readFloat" () in
        def readUTF = Java.jmethod "readUTF" () in
    }
}
