type DataOutputStream = {
    with OutputStream
    def flush: ()
    def writeInt(n: int): ()
    def writeFloat(x: float): ()
    def writeUTF(str: string): ()
}

newtype DataOutputStreamModule = {
    def create(funnelstream: OutputStream): DataOutputStream
    def class: null
    def new(javastream: any): DataOutputStream
    def extend(funnelstream: OutputStream, javastream: any): DataOutputStream
}

let DataOutputStream: DataOutputStreamModule = {
    val class = Java.jclass "java.io.DataOutputStream"
    def create(stream) = {
        val newstream = Java.jconstructor(OutputStream.class)class(stream.toJava)
        extend(OutputStream.new(newstream), newstream)
    }
    def new(out) = extend(OutputStream.new(out), out)
    def extend(stream, out) = {
        with stream
        def flush = Java.jmethod "flush" () out
        def writeInt(n) = Java.jmethod "writeInt" (Java.int_type) out n
        def writeFloat(x) = Java.jmethod "writeInt" (Java.float_type) out x
        def writeUTF(str) = Java.jmethod "writeUTF" (Java.java_lang_String) out str
    }
}
