type InetAddress = {
    def getHostName: string
    def toString: string
    def toJava: any
}

newtype InetAddressModule = {
    def create(host: string): InetAddress
    def getLocalHost: InetAddress
    def new(javainet: any): InetAddress
}

let InetAddress: InetAddressModule = {
    val class = Java.jclass "java.net.InetAddress"
    def create(host) = new(Java.jmethod "getByName" (Java.java_lang_String)
                                  class host)
    def getLocalHost = new(Java.jmethod "getLocalHost" () class)
    def new(toJava) = {
        def getHostName = Java.jmethod "getHostName" () toJava
        def toString = Java.jmethod "toString" () toJava
    }
}
