type InputStream = {
    def available: int
    def close: ()
    def mark(x: int): ()
    def markSupported: boolean
    def read: int
    def reset: ()
    def toJava: any
}

newtype InputStreamModule = {
    def class: null
    def new(javastream: any): InputStream
}

let InputStream: InputStreamModule = {
    val class = Java.jclass "java.io.InputStream"
    def new(in) = {
        def available = Java.jmethod "available" () in
        def close = Java.jmethod "close" () in
        def mark = Java.jmethod "mark" (Java.int_type) in
        def markSupported = Java.jmethod "markSupported" () in
        def read = Java.jmethod "read" () in
        def reset = Java.jmethod "reset" () in
        def toJava = in
    }
}
