type OutputStream = {
    def close: ()
    def flush: ()
    def write(x: int): ()
    def toJava: any
}

newtype OutputStreamModule = {
    def class: null
    def new(javastream: any): OutputStream
}

let OutputStream: OutputStreamModule = {
    val class = Java.jclass "java.io.OutputStream"
    def new(out) = {
        def close = Java.jmethod "close" () out
        def flush = Java.jmethod "flush" () out
        def write = Java.jmethod "write" (Java.int_type) out
        def toJava = out
    }
}
