type PrintWriter = {
    def close: ()
    def flush: ()
    def write(x: int): ()
    def writeString(str: string): ()
}

newtype PrintWriterModule = {
    def create(funneloutstream: OutputStream): PrintWriter
    def new(javawriter: any): PrintWriter
}

let PrintWriter: PrintWriterModule = {
    val class = Java.jclass "java.io.PrintWriter"
    def create(stream) = {
        new(Java.jconstructor(OutputStream.class)class(stream.toJava))
    }
    def new(writer) = {
        def close = Java.jmethod "close" () writer
        def flush = Java.jmethod "flush" () writer
        def write = Java.jmethod "write" (Java.int_type) writer
        def writeString = Java.jmethod "write" (Java.java_lang_String) writer
    }
}
