type Socket = {
    def toJava: any
    def close: ()
    def getInetAddress: InetAddress
    def getInputStream: InputStream
    def getLocalPort: int
    def getOutputStream: OutputStream
    def getPort: int
    def toString: string
}

newtype SocketModule = {
    def class: null
    def create(host: string, port: int): Socket
}

let Socket: SocketModule = {
    val class = Java.jclass "java.net.Socket"
    def create(host, port) = {
        val toJava = Java.jconstructor (Java.java_lang_String, Java.int_type)
                         class host port
        def close = Java.jmethod "close" () toJava
        def getInetAddress = InetAddress.new(Java.jmethod "getInetAddress" () toJava)
        def getInputStream = InputStream.new(Java.jmethod "getInputStream" () toJava)
        def getLocalPort = Java.jmethod "getLocalPort" () toJava
        def getOutputStream = OutputStream.new(Java.jmethod "getOutputStream" ()
                                               toJava)
        def getPort = Java.jmethod "getPort" () toJava
        def toString = Java.jmethod "toString" () toJava
    }
}
