/*  Funnel prelude
**  
**  09/01/00, Matthias Zenger
*/

// stop execution
val error: any -> null = primitive 0;

// return system time in msec
def time:int = (primitive 2) "currentTimeMillis" ()
				  ((primitive 1) "java.lang.System")

// general functions

def fst[a, b](x: a, y: b): a = x
def snd[a, b](x: a, y: b): b = y
def curry[a, b, c](f: (a, b) -> c)(x: a)(y: b): c = f(x, y)
def uncurry[a, b, c](f: a -> b -> c)(x: a, y: b): c = f x y
def id[a](x: a): a = x
def const[a](k: a)(l: any): a = k
def compose[b, c](f: b -> c)[a](g: a -> b)(x: a): c = f(g x)
def flip[a, b, c](f: a -> b -> c)(x: b)(y: a): c = f y x
def until[a](p: a -> bool)(f: a -> a)(x: a): a = if (p x) x else until[a] p f (f x)

def abs(x: int): int = if (x < 0) -x else x

// control constructs

def while(cond: () -> bool)(body: () -> ()): () = {
    if (cond()) {
        body(); while cond body
    } else
        ()
}

def for(start: int)(stop: int)(by: int)(do: int -> ()): () = {
    if (start <= stop) {
        do start
        for (start + by) stop by do
    } else
        ()
}
